// AvionicsDoc.cpp : implementation of the CAvionicsDoc class
//

#include "stdafx.h"
#include "Avionics.h"
//#include "AIFInput.h"
#include "AIFRead.h"
#include "AvionicsDoc.h"
//#include <fstream.h>
 
#include "AllocateComponentsDlg.h"
#include "TA_MFC_Support.h"
#include "TA_XSLT_Support.h"
#include "UdmCORBA.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAvionicsDoc

IMPLEMENT_DYNCREATE(CAvionicsDoc, CDocument)

BEGIN_MESSAGE_MAP(CAvionicsDoc, CDocument)
	//{{AFX_MSG_MAP(CAvionicsDoc)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_ACTIONS_ASSIGN_RATES, OnActionsAssignRates)
	ON_COMMAND(ID_ACTIONS_ASSIGN_COMPONENTS, OnActionsAssignComponents)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLOSE, OnUpdateFileClose)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAvionicsDoc construction/destruction
using namespace AIF;

CAvionicsDoc::CAvionicsDoc() : backend(new Udm::SmartDataNetwork(AIF::diagram))
//CAvionicsDoc::CAvionicsDoc():backend(new Udm::SmartDataNetwork(AIF::diagram))
//CAvionicsDoc::CAvionicsDoc():tool_adaptor("AIF_RECEIVER", __argc, __argv),
//backend(AIF::diagram)
{
	// TODO: add one-time construction code here

}

CAvionicsDoc::~CAvionicsDoc()
{
#if 1
	if(backend->isOpen()) {
		backend->CloseNoUpdate();
	}
//	CleanupGlobalLists();
	gTheSystem.Cleanup();
	delete backend;
	backend = NULL;
#endif
}

BOOL CAvionicsDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	//gTheSystem.Cleanup();
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAvionicsDoc serialization

void CAvionicsDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CAvionicsDoc diagnostics

#ifdef _DEBUG
void CAvionicsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAvionicsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
bool gAIFFileOpened;
/////////////////////////////////////////////////////////////////////////////
// CAvionicsDoc commands
void CAvionicsDoc::OpenAIFFile() {
	CString errstr;

	ASSERT(backend);
	try{
		if(backend->isOpen()) {
			backend->CloseWithUpdate();
		}
		backend->OpenExisting((LPCTSTR)m_pathName);

		gTheSystem.Initialize(backend);

		bool ret = gTheSystem.thePEDG.CheckCycles();
		if(ret) {
			AfxMessageBox("Circular dependencies exist. Please view warning report.");
		}

		TreeView->Populate();
		ListView->DisplayProcessors();
	}
	catch(const udm_exception &e)
	{
		errstr ="Exception: initializing AIF data: ";
		errstr = errstr + (CString)e.what();
        AfxMessageBox(errstr);
  		_sleep(4000);
		exit(__LINE__);

	} 

	gAIFFileOpened = true;
}

BOOL CAvionicsDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
//	if (!CDocument::OnOpenDocument(lpszPathName))
	//	return FALSE;
	CString pathName(lpszPathName);
	
	if(pathName.Right(4) != ".xml") {
		AfxMessageBox("Invalid file extension!");
		return FALSE;
	}
	gAIFFileNameString = pathName;
	/*
	gTheSystem.theCEDG.DFSPath.add(1);
	gTheSystem.theCEDG.DFSPath.add(4);
	gTheSystem.theCEDG.DFSPath.add(3);
	gTheSystem.theCEDG.DFSPath.add(78);
	gTheSystem.theCEDG.DFSPath.add(82); 
	gTheSystem.theCEDG.DFSPath.add(89);
	gTheSystem.theCEDG.DFSPath.del(89);
	gTheSystem.theCEDG.DFSPath.add(84);
	gTheSystem.theCEDG.DFSPath.del(84);
	return true;
	*/
	m_pathName = pathName;
	OpenAIFFile();
	return TRUE;
}



#if 0
void CAvionicsDoc::OnFileSaveAif() 
{
	if(backend.isOpen()) {
		backend.CloseWithUpdate();
	}
	gTheSystem.Cleanup();
	TreeView->Populate();
	ListView->DisplayProcessors();
}
#endif

/*
void CAvionicsDoc::OnViewNormalMode() 
{
	gCurrentMode = NORMAL;
	TreeView->Populate();
}

void CAvionicsDoc::OnUpdateViewNormalMode(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(gCurrentMode == NORMAL);
}

void CAvionicsDoc::OnViewFaultMode() 
{
	gCurrentMode = FAULT;
	//UpdateAllViews(NULL);
	TreeView->Populate();
}

void CAvionicsDoc::OnUpdateViewFaultMode(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(gCurrentMode == FAULT); CFileDialog
}
*/

void CAvionicsDoc::OnFileSaveAs() 
{
#if 0
	//Testing code.
	if(backend->isOpen()) {
		//backend.CloseWithUpdate();
		backend->SaveAs("c:\\temp\\test1.xml");
	}
	gTheSystem.Cleanup();
	TreeView->Populate();
	ListView->DisplayProcessors();
	return;
#endif 
	//////////////////////////////////////
	ASSERT(gAIFFileOpened);
	CFileDialog dlg(FALSE);
	if(IDOK != dlg.DoModal()) return;
	
	CString temp;
	CString pathName = dlg.GetPathName();
	FILE *file = fopen(pathName, "w");
	if(!file) {
		CString cs;
		cs.Format("Error: the file %s cannot be opened for writing!", pathName);
		AfxMessageBox(cs);
		return;
	}

	CString text;
	//text += "Configuration: \n -------------------\n\n";
	//for(int i = 0; i <= 1; i++) {
		//mode_t mode = i == 0 ? NORMAL : FAULT;
		//text += i == 0 ? "\nNORMAL Mode:\n" : "\nFAULT Mode:\n";
		//text += "Configuration: \n -------------------\n";
		//const CSystem &system = gModalSystems[i];
		POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			text += pNode->name;
			text += "\n[\n";
			POSITION pos2 = pNode->components.GetHeadPosition();
			while(pos2) {
				CComponentNode *cNode = pNode->components.GetNext(pos2);
				//text += "\t";
				text += cNode->name;
				text += "\n\t[\n";
				POSITION pos3 = cNode->ports.GetHeadPosition();
				while(pos3) {
					CPortNode *pNode = cNode->ports.GetNext(pos3);
					text += "\t";
					text +=  pNode->GetName();
					text += "\n";
				}
				text += "\t]\n";
			}
			text += "]\n";
		}


		pos = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			text += pNode->name;
			text += "\n[\n";
			for(int i = 0; i < NUM_RATES; i++) {
				CTaskNode *tNode = &pNode->tasks[i];
				if(tNode->ports.GetCount() == 0) continue;
				text += tNode->GetName();
				CString temp;
				temp.Format(" WCET: %.2lf, WCRT: %.2lf", tNode->wcet, tNode->wcrt);
				text += temp;
				text += "\n\t[\n";
				POSITION pos3 = tNode->ports.GetHeadPosition();
				while(pos3) {
					CPortNode *pNode = tNode->ports.GetNext(pos3);
					text += "\t";
					text += pNode->parentComp->GetName() + "." + pNode->GetName();
					text += "\n";
				}
				text += "\t]\n";
			}
			text += "]\n";
		//}
	/*	
		text += "System Slack: ";
		temp.Format("%.2lf", system.slack);
		text += temp;

		text += "\nEnd-to-End Transactions: \n---------------------\n";
		pos = system.taskChainList.GetHeadPosition();
		while(pos) {
			CTaskChain *tChain = system.taskChainList.GetNext(pos);
			text += tChain->name;
			text += "\n[\n";
			POSITION pos2 = tChain->taskNodeList.GetHeadPosition();
			while(pos2) {
				CTaskNode *tNode = tChain->taskNodeList.GetNext(pos2);
				text += tNode->name;
				text += "\n";
			}
			text += "]\n";
		}

	*/
/*
		text += "\n\nProcessor Details: \n----------------------\n";
		text +=         "ID : Name : NumTasks : Utilization : Util Bound\n";
		pos = gTheSystem.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
			temp.Format("%d : %s : %.2lf : %.2lf\n", pNode->id, pNode->name, 
				pNode->utilization, pNode->utilizationBound);
			text += temp;
		}

		text += "\n\nTask Details: \n-------------------\n\n";
		text += "Name : Priority : Period : WCET : Utilization : Deadline : BCRT : WCRT : Schedulable\n";
		pos = system.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = system.processorNodeList.GetNext(pos);
			text += pNode->name;
			text += ":\n";
			POSITION pos2 = pNode->taskNodeList.GetHeadPosition();
			while(pos2) {
				CTaskNode *tNode = pNode->taskNodeList.GetNext(pos2);
				temp.Format("%s : %d : %d : %.2lf : %.2lf : %.2lf : %.2lf : %.2lf : %s\n",
					tNode->name,  tNode->priority,
					tNode->period, tNode->wcet, tNode->wcet/tNode->period, tNode->deadline,
					tNode->bcrt, tNode->wcrt, tNode->wcrt < tNode->deadline ? "Y" : "N");
				text += temp;
			}
		}

		text += "\n\nComponent Details: \n-----------------\n";
		text += "Name : WCET : Period : Utilization\n";
		pos = system.processorNodeList.GetHeadPosition();
		while(pos) {
			CProcessorNode *pNode = system.processorNodeList.GetNext(pos);
			POSITION pos2 = pNode->taskNodeList.GetHeadPosition();
			while(pos2) {
				CTaskNode *tNode = pNode->taskNodeList.GetNext(pos2);
				text += pNode->name;
				text += "/";
				text += tNode->name;
				text += ":\n";
				POSITION pos3 = tNode->compNodeList.GetHeadPosition();
				while(pos3) {
					CCompNode *cNode = tNode->compNodeList.GetNext(pos3);
					temp.Format("%s : %.2lf : %d : %.2lf\n", cNode->name, cNode->wcet, tNode->period, cNode->wcet/tNode->period);
					text += temp;
				}
				text += "\n";
			}
		}
		*/
/*
		text += "\nEnd-to-End Transaction Details: \n---------------------\n\n";
		text += "Name : Period : Deadline : Slack\n";
		pos = system.taskChainList.GetHeadPosition();
		while(pos) {
			CTaskChain *tChain = system.taskChainList.GetNext(pos);
			temp.Format("%s : %d : %.2lf : %.2lf\n", tChain->name, tChain->period, tChain->deadline, tChain->slack);
			text += temp;
		}
		*/
		text += "\n\n--------------------------------------------\n";
	}
	fprintf(file, "%s", text);
	fclose(file);

}

void CAvionicsDoc::OnFileClose() 
{
	ASSERT(gAIFFileOpened);
	if(backend->isOpen()) {
		if(AfxMessageBox("Would you like to save your changes to the AIF file?", MB_YESNO) ==
			IDNO) 
			backend->CloseNoUpdate();
		else {
			BeginWaitCursor();
			backend->CloseWithUpdate();
			EndWaitCursor();
		}
	}

	gTheSystem.Cleanup();
	TreeView->Populate();
	ListView->DisplayProcessors();

	gAIFFileOpened = false;
	CDocument::OnNewDocument();
}
#if 0
void CAvionicsDoc::OnFileWaitAif() 
{

// instantiate a tooladaptor, login with the specific type of
// ToolAdaptor into the Backplane
myToolAdaptor *ta = new myToolAdaptor("AIF_RECEIVER", __argc, __argv);
//addStringFetchDlg("Subscribe to AIF paradigm v1.0");
// subscribe to the paradigm (metamodel) (here the ecsl paradigm),
// the ecsl::diagram variable is defined in the {paradigm_name}.h
// (here, ecsl.h)
ta->subscribe(AIF::diagram);
//addStringFetchDlg("Waiting for Datanetworks...");
// run the tooladaptor, this is an infinite loop to check the arrived
// documents
ta->run();
	
}
#endif
extern CSystem gTheSystem;



//Keep it simple, assume that all the threads have been created in GME and correct.,
//All I am doing is to wire up the thread with subports.
void CAvionicsDoc::OnActionsAssignRates() 
{
  //  if(IDNO == AfxMessageBox("This action will overwrite the original thread-to-port mappings. \
//Would you like to continue?", MB_YESNO))
//	   return;
	BeginWaitCursor();
	gTheSystem.AssignRatesToPEDG();
	gTheSystem.TimingAnalysis();
	EndWaitCursor();
	TreeView->Populate();
	if(IDYES == AfxMessageBox("Would you like to update the AIF file with your changes?\
The change will only take effect when you close the file.", MB_YESNO)) {
		BeginWaitCursor();
		UpdateAIFWithRateAssignment(backend);
		BeginWaitCursor();
	}
}

//Move components from one processor to another
//causes application crash.

void CAvionicsDoc::OnActionsAssignComponents() 
{
	CAllocateComponentsDlg dlg;
	dlg.DoModal();
#if 0
	System system = System::Cast(backend.GetRootObject());
	set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		int size = procs.size();

		Processor processorOCP1;
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			Processor processor = *ii2;
			int guid = atoi(string(processor.guid()).c_str());
			CProcessorNode *processorNode = gTheSystem.FindProcessorNodeByGUID(guid);
			CString processorName = string(processor.name()).c_str();
			if(processorName == "OCP_P2") {
				processorOCP1 = processor;
			}

			set<Process> processes = processor.Process_kind_children();
			for(set<Process>::iterator ii3 = processes.begin(); ii3 != processes.end(); ii3++) {
				set<Component> comps2 = Process::Cast(*ii3).Component_kind_children();
				for(set<Component>::iterator ii4 = comps2.begin(); ii4 != comps2.end(); ii4++) {
					ComponentInstance cInst = Component::Cast(*ii4).dst_end();
					CComponentNode *cNode = gTheSystem.FindCompNodeByGUID(atoi(string(cInst.guid()).c_str()));
					processorNode->AddComponent(cNode);
				}
			}
			if(processorName == "OCP_P1") {
			set<ComponentInstance> cInsts = processor.ComponentInstance_kind_children();
			for(set<ComponentInstance>::iterator ii5 = cInsts.begin(); ii5 != cInsts.end(); ii5++) {
				ComponentInstance cInst = *ii5;
//This line doesnt work.
				processorOCP1.ComponentInstance_children() += cInst;
			}
			}
		}
	}
#endif
}
/*
void CAvionicsDoc::OnCloseDocument() 
{
	if(backend.isOpen()) {
		backend.CloseWithUpdate();
	}
	gTheSystem.Cleanup();
	TreeView->Populate();
	ListView->DisplayProcessors();
	CDocument::OnCloseDocument();
}
*/

void CAvionicsDoc::OnFileSave() 
{
	OnFileSaveAs();	
}

void CAvionicsDoc::OnUpdateFileClose(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);	
}

void CAvionicsDoc::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!gAIFFileOpened);	
}
