// MyTreeView.cpp : implementation file
//

#include "stdafx.h"
#include "Avionics.h"
#include "MyTreeView.h"
#include "AvionicsDoc.h"
#include "AIFRead.h"
#include "E2ETimeline.h"
#include "CPUMappingDlg.h"
#include "WarningReportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView CTreeCtrl

IMPLEMENT_DYNCREATE(CMyTreeView, CTreeView)

CMyTreeView::CMyTreeView()
{
}

CMyTreeView::~CMyTreeView()
{
}


BEGIN_MESSAGE_MAP(CMyTreeView, CTreeView)
	//{{AFX_MSG_MAP(CMyTreeView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_COMMAND(ID_FORWARD_REACHABLE, OnForwardReachable)
	ON_COMMAND(ID_BACKWARD_REACHABLE, OnBackwardReachable)
	ON_COMMAND(ID_VIEW_WARNING_REPORT, OnViewWarningReport)
	ON_COMMAND(ID_VIEW_E2ETIMELINE, OnViewE2etimeline)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_COMMAND(IDR_MENU_SORT, OnMenuSort)
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(IDR_MENU_COMP_BSLICE, OnMenuCompBslice)
	ON_COMMAND(IDR_MENU_COMP_FSLICE, OnMenuCompFslice)
	ON_COMMAND(IDR_MENU_PORT_BSLICE, OnMenuPortBslice)
	ON_COMMAND(IDR_MENU_PORT_FSLICE, OnMenuPortFslice)
	ON_UPDATE_COMMAND_UI(ID_FORWARD_REACHABLE, OnUpdateForwardReachable)
	ON_UPDATE_COMMAND_UI(ID_BACKWARD_REACHABLE, OnUpdateBackwardReachable)
	ON_UPDATE_COMMAND_UI(ID_VIEW_E2ETIMELINE, OnUpdateViewE2etimeline)
	ON_UPDATE_COMMAND_UI(IDR_MENU_SORT, OnUpdateMenuSort)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COMP_GRAPH, OnUpdateViewCompGraph)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PEDG, OnUpdateViewPedg)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WARNING_REPORT, OnUpdateViewWarningReport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView drawing

void CMyTreeView::OnDraw(CDC* pDC)
{
	//CAvionicsDoc* pDoc = (CAvionicsDoc *)GetDocument();
	Populate();
	//pDoc->ListView->DisplayProcessors();
}

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView diagnostics

#ifdef _DEBUG
void CMyTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CMyTreeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyTreeView message handlers

int CMyTreeView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	lpCreateStruct->style |= ( TVS_HASLINES | TVS_HASBUTTONS | TVS_LINESATROOT );

	if ( CTreeView::OnCreate( lpCreateStruct ) == (-1) )
	{
	   return( -1 );
	}

	CAvionicsDoc * document_p = (CAvionicsDoc *)GetDocument();

	ASSERT( document_p != NULL );

	document_p->TreeView = this;

	ImageList.Create( IDB_IMAGELIST, 16, 0, RGB( 255, 0, 255 ) );
	ImageList.SetBkColor( GetSysColor( COLOR_WINDOW ) );

	CTreeCtrl& tree_control = GetTreeCtrl();

	tree_control.SetImageList( &ImageList, TVSIL_NORMAL );

	UpdateWindow();

	RootItem = tree_control.InsertItem( "Component View", IMAGE_ROOT, IMAGE_ROOT_SEL);
	RootItem2 = tree_control.InsertItem( "Task View", IMAGE_TILE_5, IMAGE_TILE_5_SEL);
//	Populate();
	return( 0 );
}

void CMyTreeView::DeleteChildren( HTREEITEM parent_item )
{
   CTreeCtrl& tree_control = GetTreeCtrl();

   HTREEITEM child_item = (HTREEITEM) NULL;

   child_item = tree_control.GetChildItem( parent_item );

   while( child_item != NULL )
   {
      tree_control.DeleteItem( child_item );
      child_item = tree_control.GetChildItem( parent_item );
   }
}

DWORD CMyTreeView::ImageToWhatItIs( DWORD image_id ) const
{
   switch( image_id )
   {
      case IMAGE_ROOT:

         return( IT_IS_THE_ROOT );

      case IMAGE_TILE_2:

         return( IT_IS_AN_XML_DOCUMENT );

      case IMAGE_TILE_3:

         return( IT_IS_AN_ELEMENT );

      default:

         return( 0 );
   }
}

/*
void CMyTreeView::Populate( CExtensibleMarkupLanguageDocument * xml_p )
{
   // Start with an empty tree
   DeleteChildren( RootItem );

   if ( xml_p == NULL )
   {
      return;
   }

   CTreeCtrl& tree_control = GetTreeCtrl();

   HTREEITEM document_item;

   document_item = tree_control.InsertItem( TEXT( "XML" ), IMAGE_TILE_2, IMAGE_TILE_2, RootItem );
   tree_control.SetItemData( document_item, (DWORD) xml_p );

   CExtensibleMarkupLanguageElement * element_p = xml_p->GetRootElement();

   AddElement( tree_control, document_item, element_p );
}
*/
/*
void AddDevices(set<ElectricDevice> &devs, HTREEITEM pos, CTreeCtrl& m_tree) {
	for(set<ElectricDevice>::iterator ii = devs.begin();
		ii != devs.end(); ii++) {
					HTREEITEM ht = m_tree.InsertItem(
						string(ii->name()).c_str(), 
						0, 0, pos);
					m_tree.SetItemData(ht, ii->uniqueId());
					if(ii->type() == Lamp::meta) {
						set<ElectricDevice> s = Lamp::Cast(*ii).ElectricDevice_kind_children();
						AddDevices( s, ht, m_tree);
					}
		}
}

void CMyTreeView::Populate(const RootFolder& rrr) {
	DeleteChildren ( RootItem );
	CTreeCtrl& tree_control = GetTreeCtrl();
	HTREEITEM item_level1, item_level2;
	AddDevices(set<ElectricDevice>(rrr.ElectricDevice_kind_children()) , RootItem, tree_control);	
}
*/

void CMyTreeView::Populate() {
	DeleteChildren( RootItem);
	DeleteChildren( RootItem2);
	CTreeCtrl& tree_control = GetTreeCtrl();
	tree_control.SelectItem(RootItem);
	HTREEITEM item_level1, item_level2, item_level3;
	
    //item_level1 = tree_control.InsertItem( TEXT( "XML1" ), IMAGE_TILE_2, IMAGE_TILE_2, RootItem );
	//tree_control.SetItemData( document_item, (DWORD) xml_p );
	//item_level2 = tree_control.InsertItem( TEXT( "XML2" ), IMAGE_TILE_3, IMAGE_TILE_3, item_level1 );
	/*set<Network> networks = system.Network_kind_children();
	for(set<Network>::iterator ii = networks.begin(); ii != networks.end(); ii++) {
		//AfxMessageBox((const char*)(ii->name()));
		set<Processor> procs = Network::Cast(*ii).Processor_kind_children();
		for(set<Processor>::iterator ii2 = procs.begin(); ii2 != procs.end(); ii2++) {
			tree_control.InsertItem(string(ii2->name()).c_str(), IMAGE_TILE_2, IMAGE_TILE_2, RootItem );
		
		}
	}*/
	//ASSERT(gCurrentMode == NORMAL);
	//ASSERT(gProcessorNodeList.GetCount() == 1);

	POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		item_level1 = tree_control.InsertItem(pNode->name, IMAGE_TILE_2, IMAGE_TILE_2_SEL, RootItem);
		tree_control.SetItemData(item_level1, (DWORD) pNode);

		POSITION pos2 = pNode->components.GetHeadPosition();
		while(pos2) {
			CComponentNode *cNode = pNode->components.GetNext(pos2);
			item_level2 = tree_control.InsertItem(cNode->name, IMAGE_TILE_3, IMAGE_TILE_3_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) cNode);

			POSITION pos3 = cNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *portNode = cNode->ports.GetNext(pos3);
				item_level3 = tree_control.InsertItem(portNode->GetName(), IMAGE_TILE_4, IMAGE_TILE_4_SEL, item_level2);
				tree_control.SetItemData(item_level3, (DWORD) portNode);
			}
		}
	}

	pos = gTheSystem.processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = gTheSystem.processorNodeList.GetNext(pos);
		item_level1 = tree_control.InsertItem(pNode->name, IMAGE_TILE_6, IMAGE_TILE_6_SEL, RootItem2);
		tree_control.SetItemData(item_level1, (DWORD) pNode);

		for(int i = 0; i < NUM_RATES; i++) {
			CTaskNode *tNode = &pNode->tasks[i];
			//if(tNode->wcet == 0) continue;
			//If a task doesnot contain any ports, skip over it.
//			if(tNode->ports.GetCount() == 0) continue;
			item_level2 = tree_control.InsertItem(tNode->GetName(),
				IMAGE_TILE_7, IMAGE_TILE_7_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) tNode);		
			
			POSITION pos3 = tNode->ports.GetHeadPosition();
			while(pos3) {
				CPortNode *portNode = tNode->ports.GetNext(pos3);
				//TODO:
				ASSERT(portNode->parentTask);
				//	if(portNode->type != SUBSCRIBEPORT && portNode->type != FACET) continue;
				CComponentNode *cNode = portNode->parentComp;
				item_level3 = tree_control.InsertItem(cNode->name + "." + portNode->GetName(), IMAGE_TILE_8, IMAGE_TILE_8_SEL, item_level2);
				tree_control.SetItemData(item_level3, (DWORD) portNode);
			}
			/*
			POSITION pos3 = pNode->components.GetHeadPosition();
			while(pos3) {
				CComponentNode *compNode = pNode->components.GetNext(pos3);
				if(compNode->rate == tNode->rate) {
					item_level3 = tree_control.InsertItem(compNode->name, IMAGE_TILE_8, IMAGE_TILE_8_SEL, item_level2);
					tree_control.SetItemData(item_level3, (DWORD) compNode);
				}
			}
			*/
		}
	}


    

   ////////////////////////////////////////////////////////////////////
#if 0
	
	pos = gTaskChainList.GetHeadPosition();
	while(pos) {
		CTaskChain *tChain = gTaskChainList.GetNext(pos);
		item_level1 = tree_control.InsertItem(tChain->name, IMAGE_TILE_6, IMAGE_TILE_6_SEL, RootItem2);
		tree_control.SetItemData(item_level1, (DWORD) tChain);
		POSITION pos2 = tChain->taskNodeList.GetHeadPosition();
		int tempCounter = 0;
		while(pos2) {
			CTaskNode *tNode = tChain->taskNodeList.GetNext(pos2);
			item_level2 = tree_control.InsertItem(tNode->name, IMAGE_TILE_7, IMAGE_TILE_7_SEL, item_level1);
			tree_control.SetItemData(item_level2, (DWORD) tNode);
			POSITION pos3 = tNode->compNodeList.GetHeadPosition();
			while(pos3) {
				CCompNode *cNode = tNode->compNodeList.GetNext(pos3);
				item_level3 = tree_control.InsertItem(cNode->name, IMAGE_TILE_8, IMAGE_TILE_8_SEL, item_level2);
				tree_control.SetItemData(item_level3, (DWORD) cNode);
			}
		}
	}
#endif
}

void CMyTreeView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
#if 1
	CAvionicsDoc* pDoc = (CAvionicsDoc *)GetDocument();
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	TVITEM		newItem = pNMTreeView->itemNew;
	CTreeCtrl& tree_control = GetTreeCtrl();
	if (newItem.mask & TVIF_HANDLE) {
		int image, selectedImage;
		tree_control.GetItemImage(newItem.hItem, image, selectedImage);
		CProcessorNode *pNode;
		CComponentNode *cNode;
		CTaskNode *tNode;
	//	CTaskChain *tChain;
		switch(image) {

			case IMAGE_ROOT: 
				pDoc->ListView->DisplayProcessors();
				break;
			case IMAGE_TILE_2:
				pNode = (CProcessorNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayComponents(pNode);
				break;
			case IMAGE_TILE_3:
				cNode = (CComponentNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayComponentDetails(cNode);
				break;
			case IMAGE_TILE_4:
				pDoc->ListView->DisplayPortDetails((CPortNode *) tree_control.GetItemData(newItem.hItem));
				break; 

			case IMAGE_TILE_5: 
				pDoc->ListView->DisplayProcessors();
				break;
			case IMAGE_TILE_6:
				pNode = (CProcessorNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayTasks(pNode);
				break;
			case IMAGE_TILE_7:
				tNode = (CTaskNode *) tree_control.GetItemData(newItem.hItem);
				pDoc->ListView->DisplayComponentPorts(tNode->ports);
				break;
			case IMAGE_TILE_8:
				pDoc->ListView->DisplayPortDetails((CPortNode *) tree_control.GetItemData(newItem.hItem));
				break;
			default:
				ASSERT(0);
		}
			
		//AfxMessageBox(cs);//CTreeCtrl RTTI GetItemImage
		//CString	*pNewString = (CString *) m_treeCtrl.GetItemData(newItem.hItem);
		//m_edit.SetWindowText(*pNewString);
	}
	*pResult = 0;
#endif
}
#if 0
void CMyTreeView::OnViewE2eTimeline() 
{

	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if(nImage != IMAGE_TILE_6) {
		AfxMessageBox("Please select a task chain item to view the end-to-end timeline. ");
		return;
	}
	CTaskChain *tChain = (CTaskChain *) GetTreeCtrl().GetItemData(item);

	CE2ETimeline timelineDlg;
	timelineDlg.tChain = tChain;
	timelineDlg.DoModal();
	return;

}
#endif
/*
void CMyTreeView::OnViewReserveProfile() 
{
#if 0
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if(nImage != IMAGE_TILE_2) {
		AfxMessageBox("Please select a CPU processor item to view its reserve profile. ");
		return;
	}

	CProcessorNode *pNode = (CProcessorNode *) GetTreeCtrl().GetItemData(item);

	int numTasks = pNode->taskNodeList.GetCount();
	CString cs;
	for(int i = 0; i < numTasks; i++) {
		
		for(int x = 0; x < numTasks; x++) {
			CString temp;
			temp.Format("%lf  ", pNode->reserveProfileTable[x][i]);
			cs += temp;
		}
		cs += "\n";
	}
	AfxMessageBox(cs);
#endif
}

*/

/*  Obsolete code using a tcl script to display e2e timeline.
	FILE *dat = fopen("c:\\temp\\mobies.dat", "w");
	ASSERT(dat);

	POSITION pos = tChain->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *taskNode = tChain->taskNodeList.GetNext(pos);
		fprintf(dat, "%s ", taskNode->name);
		fprintf(dat, "%d ", taskNode->deadline);
		fprintf(dat, "%.2lf ", taskNode->wcrt);
		fprintf(dat, "%.2lf\n", taskNode->wcrt - taskNode->bcrt);
	}
	//PrintTaskNode(dat, taskNode);
	fclose(dat);
	system("wish83 c:\\temp\\e2e.tcl");
*/

/*
void PrintTaskNode(FILE *dat, CTaskNode *taskNode) {
	fprintf(dat, "%s ", taskNode->name);
	fprintf(dat, "%d ", taskNode->deadline);
	fprintf(dat, "%.2lf ", taskNode->wcrt);
	fprintf(dat, "%.2lf\n", taskNode->wcet);

	POSITION pos = taskNode->adjList.GetHeadPosition();
	if(!pos) return;
	while(pos) {
		PrintTaskNode(dat, taskNode->adjList.GetNext(pos));
	}
}
*/

//This does not work very well. I need to get the cursor position instead of
//the selected item.
/*
void CMyTreeView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
#if 1
	CTreeCtrl &tree_control = GetTreeCtrl();
	HTREEITEM item = tree_control.GetSelectedItem();
	int nImage, nSelectedImage;
	tree_control.GetItemImage(item, nImage, nSelectedImage);
	if(1) {
	//	if(nImage = IMAGE_TILE_6) {
		CMenu menu;
		menu.LoadMenu(IDR_POPUP);
		menu.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
							point.x,point.y,GetParent());
	}
#endif
}
*/
#if 0
void CMyTreeView::OnMenuViewE2e() 
{
	OnViewE2eTimeline();	
}

void CMyTreeView::OnUpdateViewE2eTimeline(CCmdUI* pCmdUI) 
{

	pCmdUI->Enable(gAnalysisType == AVIONICS);	

}
#endif
void CMyTreeView::OnForwardReachable() 
{
#if 1
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if (!(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_3 || nImage == IMAGE_TILE_8)) {
		AfxMessageBox("Please select a component or port to view its forward slice.");
		return;
	}

	const char *dottyFileName = "c:\\temp\\fwdreach.dot";
	FILE *f = fopen(dottyFileName, "w");
	ASSERT(f);
	if(nImage == IMAGE_TILE_3) {
		CComponentNode *cNode = (CComponentNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Forward Slice from %s\";\n",
			 cNode->name); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");
		gTheSystem.theCEDG.reset_color();
		gTheSystem.theCEDG.DFSForwardSlice(cNode->index, f);
	} else if(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_8) {
		CPortNode *pNode = (CPortNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Forward Slice from %s\";\n",
			 pNode->GetName()); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");

		gTheSystem.thePEDG.reset_color();
		gTheSystem.thePEDG.DFSForwardSlice(pNode->index, f);
	}

	fprintf(f, "}\n;");
	fclose(f);
	CString command = "dotty " + CString(dottyFileName);
	system(command);
#endif
}

void CMyTreeView::OnBackwardReachable() 
{
#if 1
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if (!(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_3 || nImage == IMAGE_TILE_8)) {
		AfxMessageBox("Please select a component or port to view its Backward slice.");
		return;
	}

	const char *dottyFileName = "c:\\temp\\fwdreach.dot";
	FILE *f = fopen(dottyFileName, "w");
	ASSERT(f);
	if(nImage == IMAGE_TILE_3) {
		CComponentNode *cNode = (CComponentNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Backward Slice from %s\";\n",
			 cNode->name); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");

		gTheSystem.theCEDG.reset_color();
		gTheSystem.theCEDG.DFSBackwardSlice(cNode->index, f);
	} else if(nImage == IMAGE_TILE_4 || nImage == IMAGE_TILE_8) {
		CPortNode *pNode = (CPortNode *) GetTreeCtrl().GetItemData(item);
		fprintf(f, "digraph G { \n label=\"type: Backward Slice from %s\";\n",
			 pNode->GetName()); 
		fprintf(f, "size=\"7.5,10\"\n");
		fprintf(f, "page=\"8.5,11\"\n");
		fprintf(f, "nodesep=0.1\n");
		fprintf(f, "node [shape=box,height=.2,width=.1,fontname=Tahoma]\n");

		gTheSystem.thePEDG.reset_color();
		gTheSystem.thePEDG.DFSBackwardSlice(pNode->index, f);
	}

	fprintf(f, "}\n;");
	fclose(f);
	CString command = "dotty " + CString(dottyFileName);
	system(command);
#endif
}

void CMyTreeView::OnViewWarningReport() 
{	
	CWarningReportDlg dlg;
	dlg.DoModal();
		
}

void CMyTreeView::OnViewE2etimeline() 
{
	HTREEITEM item = GetTreeCtrl().GetSelectedItem();
	ASSERT(item);
	int nImage, nSelectedImage;
	GetTreeCtrl().GetItemImage(item, nImage, nSelectedImage);
	if (nImage != IMAGE_TILE_7) {
		AfxMessageBox("Please select a task to view its end-to-end timeline.");
		return;
	}

	CE2ETimeline timelineDlg;
	timelineDlg.m_taskNode = (CTaskNode *) GetTreeCtrl().GetItemData(item);
	timelineDlg.DoModal();
}
/*
void CMyTreeView::OnRButtonUp(UINT nFlags, CPoint point) 
{
    // Calling the base class function.
//    CView::OnRButtonUp(nFlags, point);
#if 0
    // Get the top level menu from the main application window.
    CWnd*  pMainWindow = AfxGetMainWnd();
    CMenu* pTopLevelMenu = pMainWindow->GetMenu();

    // Get the File popup menu from the top level menu.
    CMenu *pFileMenu = pTopLevelMenu->GetSubMenu(0);

    // Convert the mouse location to screen coordinates before passing
    // it to the TrackPopupMenu() function.
    ClientToScreen(&point);

    // Display the File popup menu as a floating popup menu in the
    // client area of the main application window.
    pFileMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON,
        point.x,
        point.y,
        pMainWindow);    // owner is the main application window

	
	CTreeView::OnRButtonUp(nFlags, point);
#endif
}
*/
/*
void CMyTreeView::OnLButtonDown(UINT nFlags, CPoint point)
{
        UINT uFlags;
        HTREEITEM htItem = GetTreeCtrl().HitTest(point, &uFlags);
        if ((htItem != NULL) && (uFlags & TVHT_ONITEM))
                GetTreeCtrl().Select(htItem, TVGN_DROPHILITE);
        CTreeView::OnLButtonDown(nFlags, point);
}

void CMyTreeView::OnRButtonDown(UINT nFlags, CPoint point)
{
        UINT uFlags;
        HTREEITEM htItem = GetTreeCtrl().HitTest(point, &uFlags);
        if ((htItem != NULL) && (uFlags & TVHT_ONITEM)) {
                m_pOldSel = GetTreeCtrl().GetSelectedItem();
                GetTreeCtrl().Select(htItem, TVGN_DROPHILITE);
        }
}
*/
void CMyTreeView::OnContextMenu(CWnd* pWnd, CPoint point)
{
        UINT uFlags;
        CTreeCtrl&      treeCtrl = GetTreeCtrl();
        CPoint ptTree = point;
        treeCtrl.ScreenToClient(&ptTree);
        HTREEITEM htItem = treeCtrl.HitTest(ptTree, &uFlags);

        if ((htItem != NULL) && (uFlags & TVHT_ONITEM)) {
                ShowPopupMenu( point );
                treeCtrl.SetItemState(htItem, 0, TVIS_DROPHILITED);
        }
        else
                CTreeView::OnContextMenu(pWnd, point);

        if (m_pOldSel != NULL) {
                treeCtrl.Select(m_pOldSel, TVGN_DROPHILITE);
                m_pOldSel = NULL;
        }
}

void CMyTreeView::ShowPopupMenu( CPoint& point )
{
        if (point.x == -1 && point.y == -1){
                //keystroke invocation
                CRect rect;
                GetClientRect(rect);
                ClientToScreen(rect);

                point = rect.TopLeft();
                point.Offset(5, 5);
        }

        CMenu menu;
        VERIFY(menu.LoadMenu(IDR_POPUP));

        CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
        CWnd* pWndPopupOwner = this;

        while (pWndPopupOwner->GetStyle() & WS_CHILD)
                pWndPopupOwner = pWndPopupOwner->GetParent();

        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
                pWndPopupOwner);
}
/*
void CMyTreeView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CTreeView::OnLButtonDown(nFlags, point);
}

void CMyTreeView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CTreeView::OnRButtonDown(nFlags, point);
}

void CMyTreeView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// TODO: Add your message handler code here
	
}
*/

#define GET_X_LPARAM(lParam)   ((int)(short)LOWORD(lParam)) 
#define GET_Y_LPARAM(lParam)   ((int)(short)HIWORD(lParam)) 

void CMyTreeView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
#if 0
	DWORD m_MousePosInt = GetMessagePos();
	CPoint m_MousePos((m_MousePosInt) & 0xFFFF, (m_MousePosInt >> 16) & 0xFFFF);
	GetTreeCtrl().ScreenToClient(&m_MousePos);

	UINT flags = 0;
	HTREEITEM m_RightClickItem = GetTreeCtrl().HitTest(m_MousePos, &flags);

	if (m_RightClickItem != NULL)
	{
		GetTreeCtrl().SelectItem(m_RightClickItem);
		ShowPopupMenu( m_MousePos );
		// Do or call your popup code
	}
}
#endif
#if 1
	CRect TreeRect;
	CTreeCtrl&      m_treectrl = GetTreeCtrl();
	HTREEITEM hItem = m_treectrl.GetFirstVisibleItem( );

	// Get the the cursor position into the screen
	DWORD Result = GetMessagePos();
	CPoint ItemPos(GET_X_LPARAM(Result), GET_Y_LPARAM(Result));

	// Retreive the coordinates of the treecrtl viwndow
	m_treectrl.GetWindowRect(&TreeRect);
	ItemPos.Offset(-TreeRect.left, -TreeRect.top);

	// Surche the item which have the focus right click. Is not the same think to the selected
	// item. During the right click, the item receive a selected option, but the selected item 
	// not change.
	while(hItem)
	{
		CRect ItemRect;
		m_treectrl.GetItemRect( hItem, &ItemRect, FALSE );

		// If thye scursor is in the bounding rectangle
		if(ItemRect.PtInRect(ItemPos))
		{
			m_treectrl.SelectItem(hItem);
			ItemPos.Offset(TreeRect.left, TreeRect.top);

			// If the Item is a main parent (no have parent) or have a children, use the SCRIPT_MAIN_
			int image, selectedImage;
			m_treectrl.GetItemImage(hItem, image, selectedImage);
		
			CMenu tmpMenu;
			switch(image) {
			case IMAGE_ROOT: 
				tmpMenu.LoadMenu(IDR_POPUP);
				break;
			case IMAGE_TILE_2:
				tmpMenu.LoadMenu(IDR_POPUP);
				break;
			case IMAGE_TILE_3:
				tmpMenu.LoadMenu(IDR_POPUP_COMPONENT);
				break;
			case IMAGE_TILE_4:
				tmpMenu.LoadMenu(IDR_POPUP_PORT);
				break; 

			case IMAGE_TILE_5: 
				tmpMenu.LoadMenu(IDR_POPUP);
				break;
			case IMAGE_TILE_6:
				tmpMenu.LoadMenu(IDR_POPUP);
				break;
			case IMAGE_TILE_7:
				tmpMenu.LoadMenu(IDR_POPUP_TASK);
				break;
			case IMAGE_TILE_8:
				tmpMenu.LoadMenu(IDR_POPUP_PORT);
				break;
			default:
				ASSERT(0);
			}
			CMenu* pPopup = tmpMenu.GetSubMenu(0);
			ASSERT(pPopup != NULL);
			if(tmpMenu.GetSafeHmenu( ))
			pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
								ItemPos.x, ItemPos.y,
								AfxGetMainWnd()); // use main window for cmds
			break;
/*			
			if(1)
			//	if(m_treectrl.ItemHasChildren( hItem ) || !m_treectrl.GetParentItem( hItem ))
			{
				CMenu tmpMenu;
				tmpMenu.LoadMenu(IDR_POPUP);

				CMenu* pPopup = tmpMenu.GetSubMenu(0);
				ASSERT(pPopup != NULL);

				if(tmpMenu.GetSafeHmenu( ))
					pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
										ItemPos.x, ItemPos.y,
										AfxGetMainWnd()); // use main window for cmds
			}
			else
			{
				CMenu tmpMenu;
				tmpMenu.LoadMenu(IDR_POPUP);

				CMenu* pPopup = tmpMenu.GetSubMenu(0);
				ASSERT(pPopup != NULL);

				if(tmpMenu.GetSafeHmenu( ))
					pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
										ItemPos.x, ItemPos.y,
										AfxGetMainWnd()); // use main window for cmds
			}
*/		}

		// Get the next visible item.
		hItem = m_treectrl.GetNextVisibleItem( hItem );
	}
	

	*pResult = 0;
}
#endif
	/*
{
	AfxMessageBox("RClicked");

	CMenu menu;
        VERIFY(menu.LoadMenu(IDR_POPUP));

        CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
        CWnd* pWndPopupOwner = this;

        while (pWndPopupOwner->GetStyle() & WS_CHILD)
                pWndPopupOwner = pWndPopupOwner->GetParent();

        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
                pWndPopupOwner);
	*pResult = 0;

}
	*/

void CMyTreeView::OnMenuSort() 
{
	HTREEITEM selected_item = GetTreeCtrl().GetSelectedItem();
	GetTreeCtrl().SortChildren(selected_item);
}
#if 0
HTREEITEM processor_item = tree_control.GetChildItem(RootItem);
//	HTREEITEM first_item = processor_item;
	while(processor_item) {
		tree_control.SortChildren(processor_item);
		processor_item = tree_control.GetNextSiblingItem(processor_item);
	}

	HTREEITEM processor_item2 = tree_control.GetChildItem(RootItem2);
	while(processor_item2) {
		HTREEITEM task_item = tree_control.GetChildItem(processor_item2);
		while(task_item) {
			tree_control.SortChildren(task_item);
			task_item = tree_control.GetNextSiblingItem(task_item);
		}
		processor_item2 = tree_control.GetNextSiblingItem(processor_item2);
	}

#endif


void CMyTreeView::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CTreeView::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	
		
}

void CMyTreeView::OnMenuCompBslice() 
{
	OnBackwardReachable(); 
	
}

void CMyTreeView::OnMenuCompFslice() 
{
	OnForwardReachable();
	
}

void CMyTreeView::OnMenuPortBslice() 
{
	OnBackwardReachable(); 
	
}

void CMyTreeView::OnMenuPortFslice() 
{
	OnForwardReachable();
	
}

void CMyTreeView::OnUpdateForwardReachable(CCmdUI* pCmdUI) 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	if(gAIFFileOpened && (image == IMAGE_TILE_3 || image == IMAGE_TILE_4 ||
		image == IMAGE_TILE_8)) {
		pCmdUI->Enable();
	} else {
		pCmdUI->Enable(false);
	}
}

void CMyTreeView::OnUpdateBackwardReachable(CCmdUI* pCmdUI) 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	pCmdUI->Enable(gAIFFileOpened && (image == IMAGE_TILE_3 || image == IMAGE_TILE_4 ||
		image == IMAGE_TILE_8 ));
}

void CMyTreeView::OnUpdateViewE2etimeline(CCmdUI* pCmdUI) 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	int image, selectedImage;
	GetTreeCtrl().GetItemImage(hItem, image, selectedImage);
	pCmdUI->Enable(gAIFFileOpened && image == IMAGE_TILE_7);
}

void CMyTreeView::OnUpdateMenuSort(CCmdUI* pCmdUI) 
{
	HTREEITEM hItem = GetTreeCtrl().GetSelectedItem();
	pCmdUI->Enable(gAIFFileOpened && hItem != NULL);
}

void CMyTreeView::OnUpdateViewCompGraph(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);	
}

void CMyTreeView::OnUpdateViewPedg(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);	
}

void CMyTreeView::OnUpdateViewWarningReport(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(gAIFFileOpened);		
}
