// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Avionics.h"
#include "AIFRead.h"
#include "MainFrm.h"
#include "MyTreeView.h"
#include "MyListView.h"
#include "E2ETimeline.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define IDC_SNAP_COMBO 202
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_TASK_GRAPH, OnViewTaskGraph)
	ON_COMMAND(ID_VIEW_COMP_GRAPH, OnViewCompGraph)
	ON_UPDATE_COMMAND_UI(ID_VIEW_COMP_GRAPH, OnUpdateViewCompGraph)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TASK_GRAPH, OnUpdateViewTaskGraph)
	ON_COMMAND(ID_VIEW_PEDG, OnViewPedg)
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_SNAP_COMBO, OnSelchangeComboBoxModes)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

void CMainFrame::OnSelchangeComboBoxModes() {
#if 0
	int curSel = m_wndToolBar.m_wndModes.GetCurSel();
	gCurrentMode = curSel == 0 ? NORMAL : FAULT;
	CMyTreeView *pView = (CMyTreeView *) m_SplitterWindow.GetPane( 0, 0);
	pView->Populate();
#endif
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

////////////////////////////////////////////////////////////////////
	#define SNAP_WIDTH 110 //the width of the combo box

    //set up the ComboBox control as a snap mode select box
    //
    //First get the index of the placeholder's position in the toolbar
    int index = 0;
    while (m_wndToolBar.GetItemID(index) != IDP_PLACEHOLDER2) index++;

    //next convert that button to a seperator and get its position
    m_wndToolBar.SetButtonInfo(index, IDP_PLACEHOLDER2, TBBS_SEPARATOR,
        SNAP_WIDTH);
	CRect rect;
    m_wndToolBar.GetItemRect(index, &rect);

    //expand the rectangle to allow the combo box room to drop down
    rect.top+=2;
    rect.bottom += 200;
#if 0
    // then .Create the combo box and show it
    if (!m_wndToolBar.m_wndModes.Create(WS_CHILD|WS_VISIBLE|CBS_AUTOHSCROLL| 
                                       CBS_DROPDOWNLIST|CBS_HASSTRINGS,
                                       rect, &m_wndToolBar, IDC_SNAP_COMBO))
    {
        TRACE0("Failed to create combo-box\n");
        return FALSE;
    }
    m_wndToolBar.m_wndModes.ShowWindow(SW_SHOW);

    //fill the combo box
    m_wndToolBar.m_wndModes.AddString("Normal Mode");
    m_wndToolBar.m_wndModes.AddString("Fault Mode");
    m_wndToolBar.m_wndModes.SetCurSel(0);
#endif
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	m_SplitterWindow.CreateStatic( this, 1, 2, WS_CHILD | WS_VISIBLE );

	CWnd * desktop_window_p = GetDesktopWindow();

	CRect rectangle;

	if ( desktop_window_p == NULL )
	{
	   rectangle.SetRect( 0, 0, 640, 480 );
	}
	else
	{
	   desktop_window_p->GetWindowRect( rectangle );
	}

	SIZE size;

	// Make the tree control pane 25% of the window size
	size.cx = (long) ( rectangle.Width() * 0.25 );
	size.cy = rectangle.Height();

	m_SplitterWindow.CreateView( 0, 0,
								 RUNTIME_CLASS( CMyTreeView ),
								 size,
								 pContext );

	// Make the list control 75% of the window size
	size.cx = rectangle.Width() - size.cx;

	m_SplitterWindow.CreateView( 0, 1,
								 RUNTIME_CLASS( CMyListView ),
								 size,
								 pContext );

	SetActiveView( (CView *) m_SplitterWindow.GetPane( 0, 0));
	CMyListView *pView = (CMyListView *) m_SplitterWindow.GetPane( 0, 1);
	pView->SetUniqueName( "MYVIEW1" );
	return( TRUE );
	
//	return CFrameWnd::OnCreateClient(lpcs, pContext);
}
/*
void DisplayEDG() {
	CString cs("digraph G { \n label=\"File: c:\\temp\\comp.dot\"; \n size = \"11,7.75\"; \n orientation = landscape; \n");
	POSITION pos = gTaskNodeList.GetHeadPosition();
	int counter = 1;
	while(pos) {
		CTaskNode *taskNode = gTaskNodeList.GetNext(pos);
		cs += "subgraph ";
		CString temp;
		temp.Format("cluster%d", counter++);
		cs += temp;
		cs += "{\n";
		cs += "node [style=filled,color=white]; \n";
		cs += "style=filled;\n";
		cs += "color=blue;\n";
		cs += "label= \"";
		cs += taskNode->name;
		cs += "\"\n";

		POSITION pos2 = taskNode->compNodeList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode = taskNode->compNodeList.GetNext(pos2);
			cs += "\"";
			cs += compNode->name;
			cs += "\"";
			cs += ";\n";
		}
		cs += "}\n";
	}

	pos = gCompNodeList.GetHeadPosition();
	while(pos) {
		CCompNode *compNode = gCompNodeList.GetNext(pos);
		POSITION pos2 = compNode->adjList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode2 = compNode->adjList.GetNext(pos2);
			cs += "\"";
			cs += compNode->name;
			cs += "\"";
			cs += " -> ";
			cs += "\"";
			cs += compNode2->name;
			cs += "\"";
			cs += ";\n";
		}
	}

	cs += "}";
	FILE *f = fopen("c:\\temp\\comp.dot", "w");
	ASSERT(f);
	fputs(cs, f);
	fclose(f);
	system("dotty c:\\temp\\comp.dot");
}
	*/


void DisplayGraph(bool isEDG) {
#if 0
	CString cs;
	cs.Format("digraph G { \n label=\"File: c:\\temp\\comp.dot; type: %s\"; \n size = \"11,7.75\"; \n orientation = landscape; \n",
		isEDG ? "Event Dependency Graph" : "Invocation Dependency Graph");
/*
	POSITION pos = gCompNodeList.GetHeadPosition();
	while(pos) {
		CCompNode *compNode = gCompNodeList.GetNext(pos);
		
		POSITION pos2 = compNode->adjList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode2 = compNode->adjList.GetNext(pos2);
			cs += compNode->name;
			cs += " -> ";
			cs += compNode2->name;
			cs += ";\n";
		}
	}
*/
	POSITION pos = gTaskNodeList.GetHeadPosition();
	int counter = 1;
	while(pos) {
		CTaskNode *taskNode = gTaskNodeList.GetNext(pos);
		cs += "subgraph ";
		CString temp;
		temp.Format("cluster%d", counter++);
		cs += temp;
		cs += "{\n";
		cs += "node [style=filled,color=white]; \n";
		cs += "style=filled;\n";
		cs += "color=blue;\n";
		cs += "label= \"";
		cs += taskNode->name;
		cs += "\"\n";

		POSITION pos2 = taskNode->compNodeList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode = taskNode->compNodeList.GetNext(pos2);
			cs += "\"";
			cs += compNode->name;
			cs += "\"";
			cs += ";\n";
		}
		cs += "}\n";
	}

	pos = gCompNodeList.GetHeadPosition();
	while(pos) {
		CCompNode *compNode = gCompNodeList.GetNext(pos);
		CCompNodeList &cNodeList = isEDG ? compNode->adjList : compNode->invocationAdjList;
		POSITION pos2 = cNodeList.GetHeadPosition();
		while(pos2) {
			CCompNode *compNode2 = cNodeList.GetNext(pos2);
			cs += "\"";
			cs += compNode->name;
			cs += "\"";
			cs += " -> ";
			cs += "\"";
			cs += compNode2->name;
			cs += "\"";
			cs += ";\n";
		}
	}

	cs += "}";
	FILE *f = fopen("c:\\temp\\comp.dot", "w");
	ASSERT(f);
	fputs(cs, f);
	fclose(f);
	system("dotty c:\\temp\\comp.dot");
#endif
}
	

void DisplayTaskGraph() {
#if 0
	CString cs("digraph G { \n label=\"File: c:\\temp\\task.dot; Type: Task Graph\"; \n size = \"11,7.75\"; \n orientation = landscape; \n");

	POSITION pos = gTheSystem.processorNodeList.GetHeadPosition();
	int counter = 1;
	while(pos) {
		CProcessorNode *processorNode = gTheSystem.processorNodeList.GetNext(pos);
		cs += "subgraph ";
		CString temp;
		temp.Format("cluster%d", counter++);
		cs += temp;
		cs += "{\n";
		cs += "node [style=filled,color=white]; \n";
		cs += "style=filled;\n";
		cs += "color=blue;\n";
		cs += "label= \"";
		cs += processorNode->name;
		cs += "\"\n";

		for(int i = 0; i < NUM_TASKS; i++) {
			CTaskNode *tNode = &processorNode->tasks[i];
			if(tNode->wcet == 0.0) continue;
			cs += "\"";
			cs += tNode->GetName();
			cs += "\"";
			cs += "[shape = parallelogram];\n";
		}

		cs += "}\n";
	}

	


/*
		POSITION pos2 = processorNode->taskNodeList.GetHeadPosition();
		while(pos2) {
			CTaskNode *taskNode = processorNode->taskNodeList.GetNext(pos2);
			cs += "\"";
			cs += taskNode->name;
			cs += "\"";
			cs += "[shape = parallelogram];\n";
		}
		cs += "}\n";
		*/
	}

	

	pos = gTaskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *taskNode = gTaskNodeList.GetNext(pos);
		POSITION pos2 = taskNode->adjList.GetHeadPosition();
		while(pos2) {
			CTaskNode *taskNode2 = taskNode->adjList.GetNext(pos2);
			cs += "\"";
			cs += taskNode->name;
			cs += "\"";
			cs += " -> ";
			cs += "\"";
			cs += taskNode2->name;
			cs += "\"";
			cs += ";\n";
		}
	}
	cs += "}";
	FILE *f = fopen("c:\\temp\\task.dot", "w");
	ASSERT(f);
	fputs(cs, f);
	fclose(f);
	system("dotty c:\\temp\\task.dot");
#endif
}
	

void CMainFrame::OnViewTaskGraph() 
{
	//DisplayTaskGraph();
	CString fileName("C:\\temp\\taskgraph.dot");
	gTheSystem.theTG.putDotty(fileName);
	CString command = "dotty " + fileName; 
	system(command);
}

void CMainFrame::OnViewCompGraph() 
{
	CString fileName("C:\\temp\\cedg.dot");
	ASSERT(gTheSystem.theCEDG.edges);
	gTheSystem.theCEDG.putDotty(fileName);
	CString command = "dotty " + fileName; 
	system(command);
}



void PrintTaskNode(FILE *dat, CTaskNode *taskNode) {
#if 0
	fprintf(dat, "%s ", taskNode->name);
	fprintf(dat, "%d ", taskNode->deadline);
	fprintf(dat, "%.2lf ", taskNode->wcrt);
	fprintf(dat, "%.2lf\n", taskNode->wcet);

	POSITION pos = taskNode->adjList.GetHeadPosition();
	if(!pos) return;
	while(pos) {
		PrintTaskNode(dat, taskNode->adjList.GetNext(pos));
	}
#endif
}

void CMainFrame::OnUpdateViewCompGraph(CCmdUI* pCmdUI) 
{
#if 0
	pCmdUI->Enable(gAnalysisType == AVIONICS);	
#endif
}

void CMainFrame::OnUpdateViewTaskGraph(CCmdUI* pCmdUI) 
{
#if 0
	pCmdUI->Enable(gAnalysisType == AVIONICS);	
#endif
}

#if 1
void CMainFrame::OnViewPedg() 
{
	CString fileName("C:\\temp\\pedg.dot");
	gTheSystem.thePEDG.putDotty(fileName);
	CString command = "dotty " + fileName; 
	system(command);
}
#endif
